--- old/usr/src/lib/libc/port/locale/wctrans.c	Tue May 20 07:58:53 2014
+++ new/usr/src/lib/libc/port/locale/wctrans.c	Tue May 20 07:58:53 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002 Tim J. Robbins.
  * All rights reserved.
@@ -26,9 +27,11 @@
  */
 
 #include "lint.h"
+#include <note.h>
 #include <errno.h>
 #include <string.h>
 #include <wctype.h>
+#include <locale.h>
 
 enum {
 	_WCT_ERROR	= 0,
@@ -37,15 +40,14 @@
 };
 
 wint_t
-towctrans(wint_t wc, wctrans_t desc)
+towctrans_l(wint_t wc, wctrans_t desc, locale_t loc)
 {
-
 	switch (desc) {
 	case _WCT_TOLOWER:
-		wc = towlower(wc);
+		wc = towlower_l(wc, loc);
 		break;
 	case _WCT_TOUPPER:
-		wc = towupper(wc);
+		wc = towupper_l(wc, loc);
 		break;
 	case _WCT_ERROR:
 	default:
@@ -56,8 +58,18 @@
 	return (wc);
 }
 
+wint_t
+towctrans(wint_t wc, wctrans_t desc)
+{
+	return (towctrans_l(wc, desc, uselocale(NULL)));
+}
+
+/*
+ * For *now* we don't support locale sensitive transforms besides toupper
+ * and tolower.
+ */
 wctrans_t
-wctrans(const char *charclass)
+wctrans_l(const char *charclass, locale_t loc)
 {
 	struct {
 		const char	*name;
@@ -68,6 +80,7 @@
 		{ NULL,		_WCT_ERROR },		/* Default */
 	};
 	int i;
+	_NOTE(ARGUNUSED(loc));
 
 	i = 0;
 	while (ccls[i].name != NULL && strcmp(ccls[i].name, charclass) != 0)
@@ -76,4 +89,10 @@
 	if (ccls[i].trans == _WCT_ERROR)
 		errno = EINVAL;
 	return (ccls[i].trans);
+}
+
+wctrans_t
+wctrans(const char *charclass)
+{
+	return (wctrans_l(charclass, uselocale(NULL)));
 }
--- old/usr/src/lib/libc/port/locale/wctype.c	Tue May 20 07:58:53 2014
+++ new/usr/src/lib/libc/port/locale/wctype.c	Tue May 20 07:58:53 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002 Tim J. Robbins.
  * All rights reserved.
@@ -29,10 +30,17 @@
 #include <ctype.h>
 #include <string.h>
 #include <wctype.h>
+#include <note.h>
+#include <locale.h>
 #include "_ctype.h"
 
+/*
+ * For now, we don't support locale specific character classes.  This is
+ * a capability that needs to be added (locales should be able to define
+ * their own character classes.)
+ */
 wctype_t
-wctype(const char *property)
+wctype_l(const char *property, locale_t loc)
 {
 	static const struct {
 		const char	*name;
@@ -57,6 +65,7 @@
 		{ NULL,		0 },		/* Default */
 	};
 	int i;
+	_NOTE(ARGUNUSED(loc));
 
 	i = 0;
 	while (props[i].name != NULL && strcmp(props[i].name, property) != 0)
@@ -63,4 +72,10 @@
 		i++;
 
 	return (props[i].mask);
+}
+
+wctype_t
+wctype(const char *property)
+{
+	return (wctype_l(property, uselocale(NULL)));
 }
--- old/usr/src/lib/libc/port/locale/wcwidth.c	Tue May 20 07:58:53 2014
+++ new/usr/src/lib/libc/port/locale/wcwidth.c	Tue May 20 07:58:53 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright (c) 1989, 1993
  *	The Regents of the University of California.  All rights reserved.
  * (c) UNIX System Laboratories, Inc.
@@ -44,19 +45,21 @@
 #include <wchar.h>
 #include "_ctype.h"
 #include "runetype.h"
+#include "localeimpl.h"
 
 #undef wcwidth
 
 int
-wcwidth(wchar_t wc)
+wcwidth_l(wchar_t wc, locale_t loc)
 {
 	unsigned int x;
+	const _RuneLocale *rl = loc->runelocale;
 
 	if (wc == 0)
 		return (0);
 
-	x = ((wc < 0 || wc >= _CACHED_RUNES) ? ___runetype(wc) :
-	    _CurrentRuneLocale->__runetype[wc]) & (_CTYPE_SWM|_CTYPE_R);
+	x = ((wc < 0 || wc >= _CACHED_RUNES) ? __runetype(rl, wc) :
+	    rl->__runetype[wc]) & (_CTYPE_SWM|_CTYPE_R);
 
 	if ((x & _CTYPE_SWM) != 0)
 		return ((x & _CTYPE_SWM) >> _CTYPE_SWS);
@@ -63,6 +66,12 @@
 	return ((x & _CTYPE_R) != 0 ? 1 : -1);
 }
 
+int
+wcwidth(wchar_t wc)
+{
+	return (wcwidth_l(wc, uselocale(NULL)));
+}
+
 #pragma weak _scrwidth = scrwidth
 
 /*
--- old/usr/src/lib/libc/port/mapfile-vers	Tue May 20 07:58:53 2014
+++ new/usr/src/lib/libc/port/mapfile-vers	Tue May 20 07:58:53 2014
@@ -28,7 +28,7 @@
 # Copyright (c) 2012, Joyent, Inc.  All rights reserved.
 # Copyright (c) 2013, OmniTI Computer Consulting, Inc. All rights reserved.
 # Copyright (c) 2013 Gary Mills
-#
+# Copyright 2014 Garrett D'Amore <garrett@damore.org>
 
 #
 # MAPFILE HEADER START
@@ -93,6 +93,86 @@
 $add amd64
 $endif
 
+SYMBOL_VERSION ILLUMOS_0.8 {	# POSIX 2008 newlocale and friends
+    protected:
+	__mb_cur_max;
+	btowc_l;
+	duplocale;
+	fgetwc_l;
+	freelocale;
+	getwc_l;
+	isalnum_l;
+	isalpha_l;
+	isblank_l;
+	iscntrl_l;
+	isdigit_l;
+	isgraph_l;
+	islower_l;
+	isprint_l;
+	ispunct_l;
+	isspace_l;
+	isupper_l;
+	iswideogram;
+	iswideogram_l;
+	iswnumber;
+	iswnumber_l;
+	iswhexnumber;
+	iswhexnumber_l;
+	iswphonogram;
+	iswphonogram_l;
+	iswspecial;
+	iswspecial_l;
+	iswalnum_l;
+	iswalpha_l;
+	iswblank_l;
+	iswcntrl_l;
+	iswctype_l;
+	iswdigit_l;
+	iswgraph_l;
+	iswlower_l;
+	iswprint_l;
+	iswpunct_l;
+	iswspace_l;
+	iswupper_l;
+	mblen_l;
+	mbrlen_l;
+	mbsinit_l;
+	mbsnrtowcs;
+	mbsnrtowcs_l;
+	mbsrtowcs_l;
+	mbstowcs_l;
+	mbtowc_l;
+	newlocale;
+	nl_langinfo_l;
+	strcasecmp_l;
+	strcasestr_l;
+	strcoll_l;
+	strfmon_l;
+	strftime_l;
+	strncasecmp_l;
+	strptime_l;
+	strxfrm_l;
+	tolower_l;
+	toupper_l;
+	towlower_l;
+	towupper_l;
+	towctrans_l;
+	uselocale;
+	wcrtomb_l;
+	wcscasecmp_l;
+	wcscoll_l;
+	wcsncasecmp_l;
+	wcsrtombs_l;
+	wcstombs_l;
+	wcswidth_l;
+	wcsxfrm_l;
+	wctob_l;
+	wctomb_l;
+	wctrans_l;
+	wctype_l;
+	wcwidth_l;
+} ILLUMOS_0.7;
+
 SYMBOL_VERSION ILLUMOS_0.7 {	# Illumos additions
     protected:
 	_glob_ext;
--- old/usr/src/lib/libc/sparc/Makefile.com	Tue May 20 07:58:53 2014
+++ new/usr/src/lib/libc/sparc/Makefile.com	Tue May 20 07:58:53 2014
@@ -22,6 +22,7 @@
 # Copyright (c) 1989, 2010, Oracle and/or its affiliates. All rights reserved.
 # Copyright (c) 2012, Joyent, Inc.  All rights reserved.
 # Copyright (c) 2013, OmniTI Computer Consulting, Inc. All rights reserved.
+# Copyright 2013 Garrett D'Amore <garrett@damore.org>
 #
 # Copyright 2011 Nexenta Systems, Inc.  All rights reserved.
 # Use is subject to license terms.
@@ -732,9 +733,6 @@
 	getwchar.o		\
 	putwchar.o		\
 	putws.o			\
-	strcasecmp.o		\
-	strcasestr.o		\
-	strncasecmp.o		\
 	strtows.o		\
 	wcsnlen.o		\
 	wcstoimax.o		\
@@ -741,7 +739,6 @@
 	wcstol.o		\
 	wcstoul.o		\
 	wcswcs.o		\
-	wscasecmp.o		\
 	wscat.o			\
 	wschr.o			\
 	wscmp.o			\
@@ -749,7 +746,6 @@
 	wscspn.o		\
 	wsdup.o			\
 	wslen.o			\
-	wsncasecmp.o		\
 	wsncat.o		\
 	wsncmp.o		\
 	wsncpy.o		\
@@ -777,7 +773,6 @@
 	wdresolve.o		\
 	_ctype.o		\
 	isascii.o		\
-	isdigit.o		\
 	toascii.o
 
 PORTI18N_COND=			\
@@ -801,11 +796,13 @@
 	gb2312.o		\
 	gbk.o			\
 	getdate.o		\
+	isdigit.o		\
 	iswctype.o		\
 	ldpart.o		\
 	lmessages.o		\
 	lnumeric.o		\
 	lmonetary.o		\
+	localeimpl.o		\
 	localeconv.o		\
 	mbftowc.o		\
 	mblen.o			\
@@ -828,9 +825,12 @@
 	runetype.o		\
 	setlocale.o		\
 	setrunelocale.o		\
+	strcasecmp.o		\
+	strcasestr.o		\
 	strcoll.o		\
 	strfmon.o		\
 	strftime.o		\
+	strncasecmp.o		\
 	strptime.o		\
 	strxfrm.o		\
 	table.o			\
@@ -840,6 +840,7 @@
 	ungetwc.o		\
 	utf8.o			\
 	wcrtomb.o		\
+	wcscasecmp.o		\
 	wcscoll.o		\
 	wcsftime.o		\
 	wcsnrtombs.o		\
--- old/usr/src/lib/libc/sparcv9/Makefile.com	Tue May 20 07:58:54 2014
+++ new/usr/src/lib/libc/sparcv9/Makefile.com	Tue May 20 07:58:54 2014
@@ -22,6 +22,7 @@
 # Copyright (c) 1989, 2010, Oracle and/or its affiliates. All rights reserved.
 # Copyright (c) 2012, Joyent, Inc.  All rights reserved.
 # Copyright (c) 2013, OmniTI Computer Consulting, Inc. All rights reserved.
+# Copyright 2013 Garrett D'Amore <garrett@damore.org>
 #
 # Copyright 2011 Nexenta Systems, Inc.  All rights reserved.
 # Use is subject to license terms.
@@ -679,9 +680,6 @@
 	getwchar.o		\
 	putwchar.o		\
 	putws.o			\
-	strcasecmp.o		\
-	strcasestr.o		\
-	strncasecmp.o		\
 	strtows.o		\
 	wcsnlen.o		\
 	wcstoimax.o		\
@@ -688,7 +686,6 @@
 	wcstol.o		\
 	wcstoul.o		\
 	wcswcs.o		\
-	wscasecmp.o		\
 	wscat.o			\
 	wschr.o			\
 	wscmp.o			\
@@ -696,7 +693,6 @@
 	wscspn.o		\
 	wsdup.o			\
 	wslen.o			\
-	wsncasecmp.o		\
 	wsncat.o		\
 	wsncmp.o		\
 	wsncpy.o		\
@@ -724,7 +720,6 @@
 	wdresolve.o		\
 	_ctype.o		\
 	isascii.o		\
-	isdigit.o		\
 	toascii.o
 
 PORTI18N_COND=			\
@@ -748,6 +743,7 @@
 	gb2312.o		\
 	gbk.o			\
 	getdate.o		\
+	isdigit.o		\
 	iswctype.o		\
 	ldpart.o		\
 	lmessages.o		\
@@ -754,6 +750,7 @@
 	lnumeric.o		\
 	lmonetary.o		\
 	localeconv.o		\
+	localeimpl.o		\
 	mbftowc.o		\
 	mblen.o			\
 	mbrlen.o		\
@@ -775,9 +772,12 @@
 	runetype.o		\
 	setlocale.o		\
 	setrunelocale.o		\
+	strcasecmp.o		\
+	strcasestr.o		\
 	strcoll.o		\
 	strfmon.o		\
 	strftime.o		\
+	strncasecmp.o		\
 	strptime.o		\
 	strxfrm.o		\
 	table.o			\
@@ -787,6 +787,7 @@
 	ungetwc.o		\
 	utf8.o			\
 	wcrtomb.o		\
+	wcscasecmp.o		\
 	wcscoll.o		\
 	wcsftime.o		\
 	wcsnrtombs.o		\
--- old/usr/src/lib/libumem/common/stub_stand.c	Tue May 20 07:58:54 2014
+++ new/usr/src/lib/libumem/common/stub_stand.c	Tue May 20 07:58:54 2014
@@ -20,6 +20,7 @@
  */
 
 /*
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
@@ -145,4 +146,19 @@
 void
 _tmem_set_cleanup(void (*f)(int, void *))
 {
+}
+
+int
+isspace(int c)
+{
+	switch (c) {
+	case ' ':
+	case '\t':
+	case '\n':
+	case '\r':
+	case '\f':
+	case '\v':
+		return (1);
+	}
+	return (0);
 }
--- old/usr/src/man/man3c/ctype.3c	Tue May 20 07:58:54 2014
+++ new/usr/src/man/man3c/ctype.3c	Tue May 20 07:58:54 2014
@@ -1,4 +1,5 @@
 '\" te
+.\" Copyright 2013 Garrett D'Amore <garrett@damore.org>
 .\" Copyright 1989 AT&T.  Copyright (c) 1992, X/Open Company Limited  All Rights Reserved.  Portions Copyright (c) 2005, Sun Microsystems, Inc.  All Rights Reserved.
 .\" Sun Microsystems, Inc. gratefully acknowledges The Open Group for permission to reproduce portions of its copyrighted documentation. Original documentation from The Open Group can be obtained online at
 .\" http://www.opengroup.org/bookstore/.
@@ -7,7 +8,7 @@
 .\" The contents of this file are subject to the terms of the Common Development and Distribution License (the "License").  You may not use this file except in compliance with the License.
 .\" You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE or http://www.opensolaris.org/os/licensing.  See the License for the specific language governing permissions and limitations under the License.
 .\" When distributing Covered Code, include this CDDL HEADER in each file and include the License file at usr/src/OPENSOLARIS.LICENSE.  If applicable, add the following below this CDDL HEADER, with the fields enclosed by brackets "[]" replaced with your own identifying information: Portions Copyright [yyyy] [name of copyright owner]
-.TH CTYPE 3C "Jan 28, 2005"
+.TH CTYPE 3C "Sep 18, 2013"
 .SH NAME
 ctype, isalpha, isalnum, isascii, isblank, iscntrl, isdigit, islower, isprint,
 isspace, isupper, ispunct, isgraph, isxdigit \- character handling
@@ -100,23 +101,7 @@
 .LP
 Functions exist for all the macros defined below. To get the function form, the
 macro name must be undefined (for example, \fB#undef isdigit\fR).
-.sp
-.LP
-For macros described with \fBDefault\fR and \fBStandard conforming\fR versions,
-standard-conforming behavior is provided for standard-conforming applications
-(see \fBstandards\fR(5)) and for applications that define
-\fB__XPG4_CHAR_CLASS__\fR before including <\fBctype.h\fR>.
-.SS "Default"
-.sp
-.ne 2
-.na
-\fB\fBisalpha()\fR\fR
-.ad
-.RS 13n
-Tests for any character for which \fBisupper()\fR or \fBislower()\fR is true.
-.RE
 
-.SS "Standard conforming"
 .sp
 .ne 2
 .na
@@ -178,7 +163,6 @@
 Tests for any decimal-digit character.
 .RE
 
-.SS "Default"
 .sp
 .ne 2
 .na
@@ -185,17 +169,6 @@
 \fB\fBisgraph()\fR\fR
 .ad
 .RS 13n
-Tests for any character for which \fBispunct()\fR, \fBisupper()\fR,
-\fBislower()\fR, and \fBisdigit()\fR is true.
-.RE
-
-.SS "Standard conforming"
-.sp
-.ne 2
-.na
-\fB\fBisgraph()\fR\fR
-.ad
-.RS 13n
 Tests for any character for which \fBisalnum()\fR and \fBispunct()\fR are true,
 or any character in the current locale-defined "graph" class which is neither a
 space ("\|") nor a character for which \fBiscntrl()\fR is true.
@@ -214,7 +187,6 @@
 as lower-case \fBASCII\fR characters.
 .RE
 
-.SS "Default"
 .sp
 .ne 2
 .na
@@ -221,17 +193,6 @@
 \fB\fBisprint()\fR\fR
 .ad
 .RS 13n
-Tests for any character for which \fBispunct()\fR, \fBisupper()\fR,
-\fBislower()\fR, \fBisdigit()\fR, and the space character ("\|") is true.
-.RE
-
-.SS "Standard conforming"
-.sp
-.ne 2
-.na
-\fB\fBisprint()\fR\fR
-.ad
-.RS 13n
 Tests for any character for which \fBiscntrl()\fR is false, and
 \fBisalnum()\fR, \fBisgraph()\fR, \fBispunct()\fR, the space character ("\|"),
 and the characters in the current locale-defined "print" class are true.
@@ -272,20 +233,8 @@
 as upper-case \fBASCII\fR characters.
 .RE
 
-.SS "Default"
 .sp
 .ne 2
-.na
-\fB\fBisxdigit()\fR\fR
-.ad
-.RS 14n
-Tests for any hexadecimal-digit character (\fB[0\(mi9]\fR, \fB[A\(miF]\fR, or
-\fB[a\(mif]\fR).
-.RE
-
-.SS "Standard conforming"
-.sp
-.ne 2
 .na
 \fB\fBisxdigit()\fR\fR
 .ad
--- old/usr/src/pkg/manifests/system-header.mf	Tue May 20 07:58:54 2014
+++ new/usr/src/pkg/manifests/system-header.mf	Tue May 20 07:58:54 2014
@@ -440,7 +440,6 @@
 file path=usr/include/ipp/ipp_config.h
 file path=usr/include/ipp/ipp_impl.h
 file path=usr/include/ipp/ippctl.h
-file path=usr/include/iso/ctype_c99.h
 file path=usr/include/iso/ctype_iso.h
 file path=usr/include/iso/limits_iso.h
 file path=usr/include/iso/locale_iso.h
@@ -457,7 +456,6 @@
 file path=usr/include/iso/time_iso.h
 file path=usr/include/iso/wchar_c99.h
 file path=usr/include/iso/wchar_iso.h
-file path=usr/include/iso/wctype_c99.h
 file path=usr/include/iso/wctype_iso.h
 file path=usr/include/iso646.h
 file path=usr/include/kerberosv5/com_err.h
@@ -1681,6 +1679,7 @@
 file path=usr/include/wctype.h
 file path=usr/include/widec.h
 file path=usr/include/wordexp.h
+file path=usr/include/xlocale.h
 file path=usr/include/xti.h
 file path=usr/include/xti_inet.h
 file path=usr/include/zone.h
--- old/usr/src/uts/common/sys/feature_tests.h	Tue May 20 07:58:54 2014
+++ new/usr/src/uts/common/sys/feature_tests.h	Tue May 20 07:58:54 2014
@@ -23,6 +23,9 @@
  * Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
+/*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
+ */
 
 #ifndef _SYS_FEATURE_TESTS_H
 #define	_SYS_FEATURE_TESTS_H
@@ -43,6 +46,7 @@
  *		199309L	    POSIX.1b-1993 compilation (Real Time)
  *		199506L	    POSIX.1c-1995 compilation (POSIX Threads)
  *		200112L	    POSIX.1-2001 compilation (Austin Group Revision)
+ *		200809L     POSIX.1-2008 compilation
  */
 #if defined(_POSIX_SOURCE) && !defined(_POSIX_C_SOURCE)
 #define	_POSIX_C_SOURCE 1
@@ -49,9 +53,9 @@
 #endif
 
 /*
- * The feature test macros __XOPEN_OR_POSIX, _STRICT_STDC, and _STDC_C99
- * are Sun implementation specific macros created in order to compress
- * common standards specified feature test macros for easier reading.
+ * The feature test macros __XOPEN_OR_POSIX, _STRICT_STDC, _STRICT_SYMBOLS,
+ * and _STDC_C99 are Sun implementation specific macros created in order to
+ * compress common standards specified feature test macros for easier reading.
  * These macros should not be used by the application developer as
  * unexpected results may occur. Instead, the user should reference
  * standards(5) for correct usage of the standards feature test macros.
@@ -77,6 +81,10 @@
  *                      the C standard. A value of 199901L indicates a
  *                      compiler that complies with ISO/IEC 9899:1999, other-
  *                      wise known as the C99 standard.
+ *
+ * _STRICT_SYMBOLS	Used in cases where symbol visibility is restricted
+ *                      by the standards, and the user has not explicitly
+ *                      relaxed the strictness via __EXTENSIONS__.
  */
 
 #if defined(_XOPEN_SOURCE) || defined(_POSIX_C_SOURCE)
@@ -144,6 +152,14 @@
 #endif
 
 /*
+ * Use strict symbol visibility.
+ */
+#if (defined(_STRICT_STDC) || defined(__XOPEN_OR_POSIX)) && \
+	!defined(__EXTENSIONS__)
+#define	_STRICT_SYMBOLS
+#endif
+
+/*
  * Large file interfaces:
  *
  *	_LARGEFILE_SOURCE
@@ -222,6 +238,8 @@
  * X/Open CAE Specification, Issue 5 (XPG5)
  * Open Group Technical Standard, Issue 6 (XPG6), also referred to as
  *    IEEE Std. 1003.1-2001 and ISO/IEC 9945:2002.
+ * Open Group Technical Standard, Issue 7 (XPG7), also referred to as
+ *    IEEE Std. 1003.1-2008 and ISO/IEC 9945:2009.
  *
  * XPG4v2 is also referred to as UNIX 95 (SUS or SUSv1).
  * XPG5 is also referred to as UNIX 98 or the Single Unix Specification,
@@ -229,6 +247,7 @@
  * XPG6 is the result of a merge of the X/Open and POSIX specifications
  *     and as such is also referred to as IEEE Std. 1003.1-2001 in
  *     addition to UNIX 03 and SUSv3.
+ * XPG7 is also referred to as UNIX 08 and SUSv4.
  *
  * When writing a conforming X/Open application, as per the specification
  * requirements, the appropriate feature test macros must be defined at
@@ -241,6 +260,7 @@
  * _XOPEN_SOURCE && _XOPEN_SOURCE_EXTENDED = 1           XPG4v2
  * _XOPEN_SOURCE = 500                                   XPG5
  * _XOPEN_SOURCE = 600  (or POSIX_C_SOURCE=200112L)      XPG6
+ * _XOPEN_SOURCE = 700  (or POSIX_C_SOURCE=200809L)      XPG7
  *
  * In order to simplify the guards within the headers, the following
  * implementation private test macros have been created. Applications
@@ -260,6 +280,7 @@
  * _XPG4_2  X/Open CAE Specification, Issue 4, Version 2 (XPG4v2/UNIX 95/SUS)
  * _XPG5    X/Open CAE Specification, Issue 5 (XPG5/UNIX 98/SUSv2)
  * _XPG6    Open Group Technical Standard, Issue 6 (XPG6/UNIX 03/SUSv3)
+ * _XPG7    Open Group Technical Standard, Issue 7 (XPG7/UNIX 08/SUSv4)
  */
 
 /* X/Open Portability Guide, Issue 3 */
@@ -294,6 +315,19 @@
 #define	_POSIX_C_SOURCE			200112L
 #undef	_XOPEN_SOURCE
 #define	_XOPEN_SOURCE			600
+
+/* Open Group Technical Standard, Issue 7 */
+#elif	(_XOPEN_SOURCE - 0 == 700) || (_POSIX_C_SOURCE - 0 == 200809L)
+#define	_XPG7
+#define	_XPG6
+#define	_XPG5
+#define	_XPG4_2
+#define	_XPG4
+#define	_XPG3
+#undef	_POSIX_C_SOURCE
+#define	_POSIX_C_SOURCE			200809L
+#undef	_XOPEN_SOURCE
+#define	_XOPEN_SOURCE			700
 #endif
 
 /*
@@ -304,12 +338,15 @@
  * with the value of 4 indicates an XPG4 or XPG4v2 (UNIX 95) application.
  * _XOPEN_VERSION  defined with a value of 500 indicates an XPG5 (UNIX 98)
  * application and with a value of 600 indicates an XPG6 (UNIX 03)
- * application.  The appropriate version is determined by the use of the
+ * application and with a value of 700 indicates an XPG7 (UNIX 08).
+ * The appropriate version is determined by the use of the
  * feature test macros described earlier.  The value of _XOPEN_VERSION
  * defaults to 3 otherwise indicating support for XPG3 applications.
  */
 #ifndef _XOPEN_VERSION
-#ifdef	_XPG6
+#if	defined(_XPG7)
+#define	_XOPEN_VERSION 700
+#elif	defined(_XPG6)
 #define	_XOPEN_VERSION 600
 #elif defined(_XPG5)
 #define	_XOPEN_VERSION 500
